%rotation demonstration
%VMR example

%data:E	N	H
coords=[
254069	3893433	645
254139	3893503	667
254080	3893496	640
254088	3893491	650
254108	3893472	652
254109	3893473	651
254143	3893455	653
254133	3893453	652
254065  3893509 999
254134  3893450 999];%last two are the SAF trace

x=coords(:,1); %pull out x and y
y=coords(:,2);

x_mean=mean(x); %compute mean as origin for rotation axis
y_mean=mean(y);

figure(1)
clf
plot(x_mean,y_mean,'bo')    %Plot rotation axis
hold on
plot(x,y,'k.', 'MarkerSize',15) %Plot points
plot([x(9) x(10)],[y(9) y(10)],'k-', 'MarkerSize',15) %plot approximate San Andreas Fault
xlabel('Easting (m)')
ylabel('Northing (m)')
axis equal %important to keep the axes scales the same

coords(:,1)=coords(:,1)-x_mean; %adjust points so that they have local origion at x and y mean
coords(:,2)=coords(:,2)-y_mean;

omegaz = 50; %rotation angle in degrees

R = [cosd(omegaz) -sind(omegaz) 0;  %2D rotation matrix 
    sind(omegaz) cosd(omegaz) 0;
    0   0 1];

coords_prime = coords*R;    %row times column
x_prime=coords_prime(:,1)+x_mean; %push the rotated points back by adding the translation to the origin back
y_prime=coords_prime(:,2)+y_mean;

plot(x_prime,y_prime,'r.', 'MarkerSize',15)
plot([x_prime(9) x_prime(10)],[y_prime(9) y_prime(10)],'r-') %red points and lines are parallel and perpendicular to the San Andreas Fault


